// security_ex.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"


#include<windows.h>
#include<stdio.h>
#include<tchar.h>
#include<iostream>
#include<vector>
#include<string>

using namespace std;
#include"LoadPlugin.h"   //implementation to load the interfaces
#include"ISQLQueryAS.h"  //Interfaces to the exported objects
 
cLoadPlugin g_plugins;    //this is a wrapper object to dynamically link to the dll
 
 
int _tmain(int argc, _TCHAR* argv[])
{
     
    ISQLiteSecurityDB *pSecurity = NULL;
	
	const char* db_name = "test";
	const char* db_table = "user_list_1";
	
	cdb_list databaseList;  //holds a vector to DBData ==> represents row
	cuser_list userList;	//holds a vector to UsersData ==> represents row
	 
	TCHAR szBasePath[1024];
    _tstring base;
    _tstring sdll;
    size_t found;
 
    //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    //Get this modules path
    //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    if( !GetModuleFileName( GetModuleHandle(NULL) , szBasePath , 1024 ) )
        return( 0 );
    base = szBasePath;
    if( (found = base.rfind( TEXT("\\") )) == base.npos )
        return( 0 );
         
    base.erase( base.begin()+found+1 , base.end() );
         
    //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    //Get Interface to IInterface
    //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    sdll = base;
    sdll+= TEXT("SQLQueryAS.dll");
    if( !g_plugins.LoadPlugin(sdll.c_str() , IID_ISQLiteSecurityDB , (void**)&pSecurity ) )
	{
		cout<<"error getting interface"<<endl;
		return( 0 );
	}
	

	//!!!!!!!!!!!!!!!!!!!!!!
	//open or create db
	// 2'd arg is for CREATE
	//!!!!!!!!!!!!!!!!!!!!!!
	pSecurity->OpenDB( "security.db" , TRUE );
     
	//add a database entry to the list
	//it creates the db_list and table if needed
	pSecurity->addDatabaseToList( db_name , "c:\\databases\\" , db_table , "admin" , "password" , 16383 );


	//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	//adding users
	//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


	//add some users using as reference tablename
	//SIMILAR: is pSecurity->addUserToDB() but uses db_name instead of tablename
	pSecurity->addUserToTable( db_table , "ADmin" , "pass" , 16383 ); //if table does not exits it is created

	//this will be added also since usernames are case-sensitive
	pSecurity->addUserToTable( db_table , "ADmiN" , "pass" , 16383 ); 
	pSecurity->addUserToTable( db_table , "ADmin3" , "pass" , 16383 );
	
	//add some more users but use the database as reference 
	//SIMILAR: is pSecurity->addUserToTable() but uses tablename instead of db_name
	pSecurity->addUserToDB( db_name , "ADmin4" , "pass" , 16383 );
	pSecurity->addUserToDB( db_name , "ADmin5" , "pass" , 16383 );

	//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	//updating username,passwords etc.
	//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	
	//chage username from "ADmin5" to "superuser"
	//SIMILAR: is pSecurity->updateUsernameInDB() but uses db_name instead of tablename
	pSecurity->updateUsernameInTable( db_table , "ADmin5" , "superuser" );
	
	//chage password of "superuser" to "TheDude" given the db_name
	pSecurity->updatePasswordInDB( db_name , "superuser" , "TheDude" );
	//chage user permission of "superuser" given table
	pSecurity->updatePermissionInTable( db_table , "superuser" , 123456 );

	
	pSecurity->updateDBpath( db_name , "e:\\databases\\" );


	//get record that belongs to db_name
	databaseList.data.clear();
	pSecurity->getDBRecord( db_name , &databaseList );


	//get record that belongs to "superuser" 
	userList.data.clear();
	if( !pSecurity->getUserRecord( db_table , "superuser" , &userList ))
	{
		cout<<"Unable to get record: possible the uSEr does not exist or some other error: remember CaSe SeSitIVe"<<endl;
	}
 


	//!!!!!!!!!!!!!!!!!!!!!!!!!!
	//get and display databse list
	//!!!!!!!!!!!!!!!!!!!!!!!!!!
	databaseList.data.clear(); //clear the list
	pSecurity->getDBList( &databaseList );
	cout<<"Database list in the 'db_list' table"<<endl;
	for( int i=0; i < databaseList.data.size() ; i++ )
	{
		cout<<"id            = "<<databaseList.data[i].id <<endl;
		cout<<"db_name       = "<<databaseList.data[i].db_name <<endl;
		cout<<"db_path       = "<<databaseList.data[i].db_path <<endl;
		cout<<"db_user_table = "<<databaseList.data[i].db_users_table <<endl;

		cout<<"\nServer will translate this to"<<endl;
		cout<<databaseList.data[i].db_path<<databaseList.data[i].db_name<<".db"<<endl;
		cout<<"And the '"<<databaseList.data[i].db_users_table<<"' table will be checked for user permissions"<<endl;
		cout<<"------------------------------------------------"<<endl;
	}

	//!!!!!!!!!!!!!!!!!!!!!!!!!!
	//get and display user list
	//!!!!!!!!!!!!!!!!!!!!!!!!!!
	userList.data.clear(); //clear the list
	pSecurity->getUserList( db_table , &userList );
	cout<<"\n\nUser list of '"<<db_table<<"' table"<<endl;
	for( int i=0; i < userList.data.size() ; i++ )
	{
		cout<<"id        = "<<userList.data[i].id <<endl;
		cout<<"username  = "<<userList.data[i].username <<endl;
		cout<<"password  = "<<userList.data[i].password <<endl;
		cout<<"permisson = "<<hex<<userList.data[i].iPermissions <<endl;
		cout<<"------------------------------------------------"<<endl;
	}

	//remove user "superuser" given the table name
	//SIMILAR is pSecurity->remDBUser() but uses db_name instead of tablename
	pSecurity->remUser( db_table , "superuser" );


	//!!!!!!!!!!!!!!!!!!!!!!!!!!
	//delete database entry
	//and table
	//!!!!!!!!!!!!!!!!!!!!!!!!!!
	pSecurity->remDBandUserList( db_name , TRUE );


	pSecurity->Release();
  
    return( 0 );
}
